﻿var ArchivePlayer =
{
	status_timer : null,
	program_start_time : 0,
	program_end_time : 0,
	current_archive_time : 0,
	one_percent : 0,
	statusmessage : null,
	mode : 0,
}

ArchivePlayer.playVideo = function()
{	
	
	KeyHandler.setFocus(Main.ArchivePlayer_ID);
	
	if(Player.state == Player.PLAYING_ARCHIVE)
	{
		Player.stopVideo();
	}
	if(Player.state == Player.PAUSA_ARCHIVE)
	{
		Player.stopVideo();
	}
	if(Player.state == Player.PLAYING_LIVE)
	{
		Player.stopVideo();
	}
	
	if (Player.url == null)
    {
        ConsoleLog("No videos to play");
    }
    else
    {
        Player.state = Player.PLAYING_ARCHIVE;
		pluginAPI.setOffScreenSaver();
        Player.plugin.Play( Player.url );
        Audio.plugin.SetSystemMute(false); 
    }
	
	Display.status(this.statusmessage);

	ArchivePlayer.UpdatePlayerStatusbar();
	Display.hidemenu();
	Display.showplayer();
}

ArchivePlayer.UpdatePlayerStatusbar = function()
{
	widgetAPI.putInnerHTML(document.getElementById("pr2_duration"), "");
	widgetAPI.putInnerHTML(document.getElementById("pr2_time"), "");
	widgetAPI.putInnerHTML(document.getElementById("pr2_name"), "");
	widgetAPI.putInnerHTML(document.getElementById("pr2_descr"), "");
	document.getElementById("ch_percent").style.width="0%";
	
	var index = Main.chan_array_index;
	this.program_start_time =  parseInt(EPG.epg_array[EPG.epg_array_index][0]);

	widgetAPI.putInnerHTML(document.getElementById("ch_number"),index+1);
	widgetAPI.putInnerHTML(document.getElementById("ch_name"),KTV_API.channels[index][1]);
	widgetAPI.putInnerHTML(document.getElementById("ch_category"),KTV_API.DateMenu(this.program_start_time));
	widgetAPI.putInnerHTML(document.getElementById("time"),KTV_API.timeToString(this.current_archive_time));
	document.getElementById("ch_arch").src='http://iptv.germet.tv/logo/' + KTV_API.channels[index][0] + '.gif'
	if(this.current_archive_time <  (KTV_API.servertime - 15*60))	
		document.getElementById("ch_img").src='img/rec.png';
	else
		document.getElementById("ch_img").src='img/clock.png';
	
	widgetAPI.putInnerHTML(document.getElementById("pr1_time"), KTV_API.timeToString(EPG.epg_array[EPG.epg_array_index][0]));
	widgetAPI.putInnerHTML(document.getElementById("pr1_name"), EPG.epg_array[EPG.epg_array_index][1]);
	widgetAPI.putInnerHTML(document.getElementById("pr1_descr"), EPG.epg_array[EPG.epg_array_index][2]);

	var next = EPG.epg_array_index+1;
	
	if(next == EPG.epg_array.length)
		this.program_end_time = this.last_program_end_time;
	else
		this.program_end_time = parseInt(EPG.epg_array[next][0]);
	
	var duration = parseInt((this.program_end_time - this.program_start_time)/60);
	this.one_percent = (this.program_end_time - this.program_start_time)/100;
	var elapsed_time_percent = parseInt((this.current_archive_time - this.program_start_time)/ this.one_percent);
	var time_left = parseInt((this.program_end_time - this.current_archive_time)/60);
	
	if(elapsed_time_percent>100)
		elapsed_time_percent = 100;
	document.getElementById("ch_percent").style.width=elapsed_time_percent+"%";
	widgetAPI.putInnerHTML(document.getElementById("pr1_time_left"), "+" + time_left + "мин");
	widgetAPI.putInnerHTML(document.getElementById("pr2_name"), "Продолжительность " + duration + " минут");

}

ArchivePlayer.PlayNewTime = function()
{	
	KTV_API.getChannel_url(Main.ch_id_selected, this.current_archive_time);
	Player.setVideoURL(KTV_API.url);
	ArchivePlayer.playVideo();		
}

ArchivePlayer.TimeChecker = function()
{
	if(this.mode == 0)
	{
		if(this.current_archive_time<this.program_start_time)
		{
			EPG.selectPrevProgram();
			
			if(EPG.epg_array_index == (EPG.epg_array.length-1))
			{	
				this.current_archive_time = parseInt(EPG.epg_array[EPG.epg_array_index][0]);
			}
			
			ArchivePlayer.UpdatePlayerStatusbar();
			Display.showplayer();
		}
		if(this.current_archive_time>this.program_end_time)
		{	
			EPG.selectNextProgram();
			
			if(EPG.epg_array_index == 0)
			{
				this.current_archive_time = parseInt(EPG.epg_array[0][0]);
			}
			
			ArchivePlayer.UpdatePlayerStatusbar();
			Display.showplayer();
		}
	}	
	ArchivePlayer.UpdatePlayerStatusbar();
}
	
ArchivePlayer.PercentJump = function(percent) 
{
	this.statusmessage = percent*10 + "%";
	if(percent)
		this.current_archive_time = this.program_start_time + this.one_percent*percent*10;
	else
		this.current_archive_time = this.program_start_time;
	ArchivePlayer.TimeChecker();
	ArchivePlayer.PlayNewTime();
	Display.showplayer();
}

ArchivePlayer.MinutesJump = function(minutes) 
{
	var sign = "";
	if(minutes>0)
		var sign = "+";
	this.statusmessage =sign + minutes + " мин.";
	this.current_archive_time = this.current_archive_time + minutes*60;
	ArchivePlayer.TimeChecker();
	ArchivePlayer.PlayNewTime();
	Display.showplayer();
}

ArchivePlayer.pauseVideo = function()
{
    widgetAPI.putInnerHTML(Display.statusDiv, "ПАУЗА");
	document.getElementById("statusbar").style.display="block";
	document.getElementById("ar_pause").style.display="none";
	document.getElementById("ar_play").style.display="block";
	clearTimeout(this.status_timer); 
	Player.state = Player.PAUSA_ARCHIVE
    Player.plugin.Pause();
}

ArchivePlayer.unpauseVideo = function()
{
    document.getElementById("ar_pause").style.display="block";
	document.getElementById("ar_play").style.display="none";
    this.current_archive_time = this.current_archive_time -5;
	ArchivePlayer.PlayNewTime();
}
