﻿var widgetAPI = new Common.API.Widget();
var pluginAPI = new Common.API.Plugin();

var Main = {

	selected_channel: 0,
	selected_page: 0,
	chan_array_index: 0,
	ch_id_selected: 0,
	MODE : -1,
    MainMenu_ID : 0,
    LivePlayer_ID : 1,
    EpgMenu_ID : 2,
	CategoryMenu_ID : 3,
    ArchivePlayer_ID : 4,
    VideothekPlayer_ID : 5,
	VideothekPlayerControll_ID : 6,	
	VideothekPlayerGenres_ID : 7,
	Selectbox_ID : 8,
	next_epg : [ ],
	version : "001",
	mac_md5 : null,
	user_md5 : null,
	FAV_MODE : 0,
	cat_selector : 0,
	cat_id : 999,
	cat_name : '',
	nguide: 'off',
	stats: 0,
	hardware : null,
	
}

ConsoleLog = function (text) {

		var tm = new Date();
		var h = tm.getHours();
		var m = tm.getMinutes();
		var s = tm.getSeconds();
		var ms = tm.getMilliseconds();
		text = "[" + h + ":" + (m > 10 ? m : ("0" + m)) + ":" + (s > 10 ? s : ("0" + s)) + "," + ms + "]---" + text;
		if (navigator.userAgent.search("Maple") > 0) 
			alert(text);

		//xhr=new XMLHttpRequest();
		//xhr.open("POST", "http://192.168.178.1/?" + text, false);
		//xhr.send();			

}


Main.onLoad = function () 
{
	ConsoleLog('start');
	
	if(Setup.init() && KTV_API.init() && Player.init() && Audio.init() && Display.init() && Search.init())
	{
		KTV_API.Auth(KTV_API.login, KTV_API.password);
		if(!KTV_API.errors)
			KTV_API.getChannel_list();

		this.user_md5=MD5(KTV_API.login);
		this.selected_channel = 0;
		KeyHandler.create();
		Main.showDateAndTime();
		var networkPlugin = document.getElementById("pluginNetwork");
		var tvplug = document.getElementById("pluginTV");
		this.mac_md5 = MD5(networkPlugin.GetMAC());
		this.hardware = tvplug.GetProductCode(1);	
		//alert('KTV_API.errors ' + KTV_API.errors);
		if(!KTV_API.errors)
		{
			Main.updatePage();
			Main.updateChannel();
			document.getElementById("help_navi_menu").style.display="block";
		}
		else
		{
			try
			{
			document.getElementById("leftHalf").style.display="none";
			setTimeout("Setup.setFormular();", 1000);
			
			} catch(e){
				ConsoleLog("Setup.setFormular ERROR: "+e);
			}
		}
			
		this.MODE = this.MainMenu_ID;
		widgetAPI.sendReadyEvent();	
		KeyHandler.setFocus(this.MainMenu_ID);
		
	}
	widgetAPI.putInnerHTML(document.getElementById("version"), "GermetTV " + this.version + ' ');
}

Main.Menu = function()
{
	document.getElementById("help_navi_epg").style.display="none";
	document.getElementById("help_navi_menu").style.display="block";
	document.getElementById("help_navi_vod").style.display="none";
	document.getElementById("vod_info").style.display="none";
	document.getElementById("channelList").style.display="";
	
	if(KTV_API.chan_counter>0)
	{
		Main.updatePage();
		Main.updateChannel();
		clearTimeout(KTV_API.timerChList);
		if(Player.state == Player.PLAYING_LIVE)
			document.getElementById("back_to_player").style.display="block";
		else
			document.getElementById("back_to_player").style.display="none";
	}
	KeyHandler.setFocus(this.MainMenu_ID);
}



Main.updateModeText = function(clear)
{
	var mode_text = this.cat_name;
	if(this.FAV_MODE==0 && Main.cat_id == 999)
		mode_text = " <b style='color:green'>список всех каналов</b>";
	else if(this.FAV_MODE==1)
		mode_text = " <b style='color:red'>фавориты</b>";
	if(clear=="true")
		mode_text = '';
	if(this.nguide == 'on')
	{
		KTV_API.servertime = KTV_API.nguide_server_time;
		mode_text = " <b style='color:green'>nGuide</b>";
	}

	widgetAPI.putInnerHTML(document.getElementById("mode"), mode_text);
	
}

Main.nguideNotFound = function()
{
	Display.status('ничего не найдено<br>nGuide<br>деактивирован');
	Main.nguide = 'off';
	Main.updateModeText();
}

Main.updatePage = function()
{	
	Main.updateModeText();
	try
	{
		//KeyHandler.setFocus(this.MainMenu_ID);
		var chan = Array();
		var time = 0;
		var chan_on_page = 10;

		if(this.selected_page > KTV_API.chan_pages-1)
			this.selected_page = 0;
			
		if(this.selected_page < 0)
			this.selected_page = KTV_API.chan_pages-1;
		
		for (var index = 0; index < 10; index++)
			{
				document.getElementById("ch"+index).style.display="";
				widgetAPI.putInnerHTML(document.getElementById("time"+index), "");
				widgetAPI.putInnerHTML(document.getElementById("progress"+index), "");
				document.getElementById("percent"+index).style.width= "0%";
				widgetAPI.putInnerHTML(document.getElementById("title"+index), "");
				widgetAPI.putInnerHTML(document.getElementById("descr"+index), "");
				document.getElementById("record"+index).style.backgroundImage= "";
				document.getElementById("descr"+index).style.display="";
				document.getElementById("title"+index).style.width= "110px";
				document.getElementById("number"+index).style = "";
			}
		
		if(this.selected_page == KTV_API.chan_pages-1)
		{
			chan_on_page = KTV_API.last_page_channels_counter;
			
				for (var index = chan_on_page; index < 10; index++)
				{
					document.getElementById("ch"+index).style.display="none";
				}
				
			if(this.selected_channel > KTV_API.last_page_channels_counter-1)
				this.selected_channel = KTV_API.last_page_channels_counter-1;
		}

		for (var index = 0; index < chan_on_page; index++)
		{
			var chan_array_index = 10*this.selected_page + index;
			
			chan[index] = document.getElementById("chan"+index);
			chan[index].style.backgroundImage= "url(img/menu.png)";
			
			if(KTV_API.channels[chan_array_index][6] && KTV_API.channels[chan_array_index][5])
				document.getElementById("record"+index).style.backgroundImage= "url(img/rec_small.png)";
			
			widgetAPI.putInnerHTML(document.getElementById("number"+index), chan_array_index+1);
			document.getElementById("img"+index).src='http://iptv.germet.tv/logo/' + KTV_API.channels[chan_array_index][0] + '.gif';
			
			var time = KTV_API.channels[chan_array_index][4];
			if(time)
			{
				var Time = KTV_API.timeToString(time)
				widgetAPI.putInnerHTML(document.getElementById("time"+index), Time);
			}
			
			var percent = (KTV_API.channels[chan_array_index][5] - KTV_API.channels[chan_array_index][4])/100;
			var elapsed_time = (KTV_API.servertime - KTV_API.channels[chan_array_index][4]);
			
			if(percent)
			{
				percent = (elapsed_time/percent);
				if(percent>100)
					percent = 100;
				widgetAPI.putInnerHTML(document.getElementById("progress"+index), parseInt(percent)+"%");
				document.getElementById("percent"+index).style.width= parseInt(percent)+"%";
			}
			
			widgetAPI.putInnerHTML(document.getElementById("title"+index), KTV_API.channels[chan_array_index][1]);
			widgetAPI.putInnerHTML(document.getElementById("descr"+index), KTV_API.channels[chan_array_index][2]);
			var time_left_min = parseInt((KTV_API.channels[chan_array_index][5] - KTV_API.servertime)/60);

			if(time_left_min < KTV_API.nguide_time && this.nguide == 'on')
			{
				var next_epg = KTV_API.getNextEPG(KTV_API.channels[chan_array_index][0]);
				var style='style=""';
				if((KTV_API.channels[chan_array_index][5] - KTV_API.servertime) > 0)
				{
					style='style="color:#9cccfd;"';
					time_left_min = time_left_min + ' m';
				}
				else 
					time_left_min = '0%';
				widgetAPI.putInnerHTML(document.getElementById("time"+index), '<span >' + next_epg[4] + '</span>');
				widgetAPI.putInnerHTML(document.getElementById("descr"+index), '<span ' + style + '>' + next_epg[0] + '</span>');
				document.getElementById("percent"+index).style.width = "0%";
				widgetAPI.putInnerHTML(document.getElementById("progress"+index), '<span ' + style + '>' + time_left_min + "</span>");
			}
			

		}
	
	} catch(e){
		alert("KTV_API.Main.updatePage ERROR: "+e);
		document.getElementById("statusbar").style.display="block";
		widgetAPI.putInnerHTML(Display.statusDiv, '4: ' + e);
	}
}

Main.updateChannel = function()
{
	if(KTV_API.chan_counter>0)
	{
		for (var index = 0; index < 10; index++)
		{
			document.getElementById("chan"+index).style.backgroundImage= "url(img/menu.png)";
			document.getElementById("number"+index).style.backgroundImage = "";
		}
		
		this.chan_array_index = 10*this.selected_page + this.selected_channel;

		document.getElementById("number"+this.selected_channel).style.backgroundImage= "url(img/menu_act.png)";
		document.getElementById("chan"+this.selected_channel).style.backgroundImage= "url(img/menu_act.png)";
		this.ch_id_selected = KTV_API.channels[this.chan_array_index][0];
		Main.updateCurrentChannelEPG();
		Main.UpdatePlayerStatusbar();
	
	}
}

Main.selectNextChannel = function()
{
	this.selected_channel++;
	if(this.selected_channel>=10 || (this.selected_page == KTV_API.chan_pages-1 && this.selected_channel==KTV_API.last_page_channels_counter))
	{
		this.selected_channel = 0;
		this.selected_page++;
		Main.updatePage();
	}

	Main.updateChannel();

}

Main.selectPrevChannel = function()
{
	this.selected_channel--;
	
	if(this.selected_page == 0 && this.selected_channel<0)
	{
		this.selected_channel = KTV_API.last_page_channels_counter - 1;
		this.selected_page = KTV_API.chan_pages-1;
		Main.updatePage();
	}
	
	if(this.selected_channel<0)
	{
		this.selected_channel = 9;
		this.selected_page--;
		Main.updatePage();
		
	}
	
	Main.updateChannel();
}

Main.selectNextPage = function()
{
	this.selected_page++;
	Main.updatePage();
	Main.updateChannel();
}

Main.selectPrevPage = function()
{
	this.selected_page--;
	Main.updatePage();
	Main.updateChannel();
}

Main.PlayChannel = function()
{	
	clearTimeout(this.kinozal_live_reloader);
	Player.selected_channel = this.selected_channel;
	Player.selected_page = this.selected_page;
	Player.chan_array_index = this.chan_array_index;
	KeyHandler.setFocus(this.LivePlayer_ID);
	Display.hidemenu();
	
	Player.state = Player.PLAYING_LIVE;
	KTV_API.getChannel_url(this.ch_id_selected,0);
	Player.setVideoURL(KTV_API.url);
	Player.playVideo();
	Display.showplayer();
}		

Main.UpdatePlayerStatusbar = function()
{
	var index = this.chan_array_index;

	widgetAPI.putInnerHTML(document.getElementById("ch_number"), index+1);
	widgetAPI.putInnerHTML(document.getElementById("ch_name"), KTV_API.channels[index][1]);
	widgetAPI.putInnerHTML(document.getElementById("ch_category"), KTV_API.channels[index][7]);
	widgetAPI.putInnerHTML(document.getElementById("time"), KTV_API.timeToString(KTV_API.servertime));
	document.getElementById("ch_img").src='http://iptv.germet.tv/logo/' + KTV_API.channels[index][0] + '.gif';
	document.getElementById("ch_arch").src='';
	time = KTV_API.channels[index][4];
	
	if(time)
	{
		var Time = KTV_API.timeToString(time)
		widgetAPI.putInnerHTML(document.getElementById("pr1_time_left"), '+'+parseInt((KTV_API.channels[index][5]-KTV_API.servertime)/60)+'min');
		if(this.next_epg[2]!="")
			widgetAPI.putInnerHTML(document.getElementById("pr2_duration"), this.next_epg[2]+'min');
		widgetAPI.putInnerHTML(document.getElementById("pr1_time"), Time);
		var percent = (KTV_API.channels[index][5] - KTV_API.channels[index][4])/100;
		var elapsed_time = (KTV_API.servertime - KTV_API.channels[index][4]);
		if(percent)
		{
			percent = (elapsed_time/percent);
			if(percent>100)
				percent = 100;
			document.getElementById("ch_percent").style.width=parseInt(percent)+"%";
		}
	}
	else
	{
		widgetAPI.putInnerHTML(document.getElementById("pr1_time_left"), "");
		widgetAPI.putInnerHTML(document.getElementById("pr1_duration"), "");	
		widgetAPI.putInnerHTML(document.getElementById("pr1_time"), "");
		widgetAPI.putInnerHTML(document.getElementById("pr2_duration"), "");
		document.getElementById("ch_percent").style.width="0%";			
	}
	

	widgetAPI.putInnerHTML(document.getElementById("pr1_name"), KTV_API.channels[index][2]);
	widgetAPI.putInnerHTML(document.getElementById("pr1_descr"), KTV_API.channels[index][3]);
	widgetAPI.putInnerHTML(document.getElementById("pr2_time"), this.next_epg[4]);
	widgetAPI.putInnerHTML(document.getElementById("pr2_name"), this.next_epg[0]);
	//widgetAPI.putInnerHTML(document.getElementById("pr2_descr"), this.next_epg[1]);
}

Main.updateCurrentChannelEPG = function()
{		
	//ConsoleLog('Main.updateCurrentChannelEPG');
	widgetAPI.putInnerHTML(document.getElementById("infoList"), "");
	var index = this.chan_array_index;
	var elapsed_time = parseInt((KTV_API.servertime - KTV_API.channels[index][4])/60);
	var time_left = parseInt((KTV_API.channels[index][5]-KTV_API.servertime)/60);
	var duration = parseInt((KTV_API.channels[index][5] - KTV_API.channels[index][4])/60);
	var epg_now_prog = KTV_API.channels[index][2];
	var epg_now_descr = KTV_API.channels[index][3];

	var epg_now = "<h3>" + KTV_API.timeToString(KTV_API.channels[index][4]) + " (+" + time_left + " мин / " + duration + " мин) </h3>" + epg_now_prog + "<br>" +epg_now_descr;
	
	this.next_epg = KTV_API.getNextEPG(KTV_API.channels[index][0]);

	
	var color = "";
	if(time_left < KTV_API.nguide_time && this.nguide == 'on')
		color = "#9cccfd";
	
	var epg_next = ""
	if(this.next_epg[0]!="")
		epg_next = "<div style=\"color:"+ color + ";\"><br><br><h3>"+this.next_epg[4]+" ("+this.next_epg[2]+" мин)</h3>" +this.next_epg[0]+"<br>"+this.next_epg[1] + "</div>";
	
	var epg = epg_now+epg_next;
	if(epg_now_prog)
		widgetAPI.putInnerHTML(document.getElementById("infoList"), epg);
		
	if(KTV_API.channels[index][5])
		document.getElementById("ch_epg").style.display="block";
	else
		document.getElementById("ch_epg").style.display="none";
}
/*
Main.showStats = function()
{
	var jetzt = new Date().getTime();
	var selectbox_html = document.getElementById("selectbox");
	var html= '<iframe style="width:100%;height:460px;" src="http://stats.pristavka.de/nktv_samsung_stats_widget4player.php?myfix='+jetzt+'"></iframe>';
	html+= '<div><div id="navi_button"><img src="img/buttons/blue.png"></img></div><span id="navi_helpertext">закрыть окно статистики</span>';
	widgetAPI.putInnerHTML(selectbox_html, html);
	selectbox_html.style.display="";
}
*/
Main.add_favorite = function()
{
	if(Main.is_in_favlist(this.ch_id_selected)>-1)
		Display.status("канал уже присутствует в списке фаворитов");
	else
	{
		KTV_API.favorite_list.push(this.ch_id_selected);
		Display.status("канал добавлен в список фаворитов");
	}

	KTV_API.getChannel_list();
	Main.updatePage();
	Main.updateChannel();
}

Main.del_favorite = function()
{

	var index = Main.is_in_favlist(this.ch_id_selected);
	if(index>-1)
	{
		KTV_API.favorite_list.splice(index,1);
		Display.status("канал удален из списка фаворитов");
	}
	else
		Display.status("канал отсутствует в списке фаворитов");
	if(KTV_API.favorite_list.length==0)
	{
		Display.status("список фаворитов пуст");
		Main.FAV_MODE = 0;
	}
	KTV_API.getChannel_list();
	Main.updatePage();
	Main.updateChannel();

}

Main.is_in_favlist = function()
{
	for (var index = 0; index < KTV_API.favorite_list.length; index++)
		{
			if(this.ch_id_selected == KTV_API.favorite_list[index])
				return index
		}
	return -1
}

Main.showCategorySelector = function()
{
	this.cat_selector = 1;

	KeyHandler.setFocus(Main.Selectbox_ID);
	Selectbox.setBox('Выбор категории', KTV_API.chan_categorys);
}

Main.nGuideChanSelector = function() 
{	
	if(Main.FAV_MODE == 0)
		KTV_API.channels = KTV_API.video_Channels;		
	else
		KTV_API.channels = KTV_API.favorite_channels;
	
	for (var index = 0; index < KTV_API.channels.length; index++)
	{
		if(parseInt(KTV_API.channels[index][0])==parseInt(Main.ch_id_selected))
		{
			Main.chan_array_index = index;
			break;
		}
	}	
	
	KTV_API.countPages();
	var position = Main.chan_array_index + 1;
	
	if(position < 11)
		Main.selected_channel = position - 1;
	else if((position % 10)>0)
		Main.selected_channel = (position % 10) - 1;
	else
		Main.selected_channel =  9;
				
	if (Main.selected_channel < 4)
		Main.selected_page = Math.round(position / 10);
	else
		Main.selected_page = Math.round(position / 10) - 1;
	
	Main.updatePage();
	Main.updateChannel();
	Main.PlayChannel();
}

Main.showDateAndTime = function()
{
	var date = KTV_API.DateMenu(KTV_API.servertime);	
	widgetAPI.putInnerHTML(document.getElementById("widget_date"), date);
	var time = KTV_API.timeToString(KTV_API.servertime);	
	widgetAPI.putInnerHTML(document.getElementById("widget_time"), time);
}	

Main.saveFavorites  = function()
{
		var fileSystemObj = new FileSystem();
		var oFile=fileSystemObj.openCommonFile( "germetplayer_favorites.dat", "w");
		for (var index = 0; index < KTV_API.favorite_channels.length; index++)
		{
			oFile. writeLine(KTV_API.favorite_channels[index][0]);
		}
		fileSystemObj.closeCommonFile(oFile);
		alert('SAVE Favorites');
}
	
Main.onUnload = function()
{
	Audio.setVolume(10);
	Player.deinit();
}