﻿var Player =
{
    selected_channel: 0,
	selected_page: 0,
	chan_array_index: 0,
	plugin : null,
	mwPlugin: null,
    state : -1,
    skipState : -1,
    stopCallback : null,    /* Callback function to be set by client */
    originalSource : null,
    size: 0,
    STOPPED : 0,
    PLAYING_LIVE : 1,
	PLAYING_ARCHIVE : 2,
	PAUSA_ARCHIVE : 3,
	PLAYING_VOD : 4,
	PAUSA_VOD : 5,
	counter : 0,
	vod_duration : 0,
	vod_one_percent : 0,
	vod_current_time : 0,
	checker : null,
	checked : true,
	chan_list_updater_counter : 0,
	timer_helper : 0,
	timer_is_on : 0,
	kinozal_live_reloader : null,
}

Player.init = function()
{
    var success = true;
    
    this.state = this.STOPPED;
    
    this.plugin = document.getElementById("pluginPlayer");
    
    if (!this.plugin)
    {
         success = false;
    }

	this.mwPlugin = document.getElementById("pluginObjectTVMW");
	if (!this.mwPlugin || !this.mwPlugin.GetSource) 
	{
		success = false;
	} 
	else 
	{
		this.originalSource = this.mwPlugin.GetSource();
		this.mwPlugin.SetMediaSource();
	}

		
	this.plugin.OnBufferingStart = 'Player.onBufferingStart';
    this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
    this.plugin.OnBufferingComplete = 'Player.onBufferingComplete';
	this.plugin.OnCurrentPlayTime = 'Player.CurrentTime';
	this.plugin.OnStreamInfoReady = 'Player.OnStreamInfoReady';
	
	this.plugin.OnConnectionFailed = 'Player.OnConnectionFailed';
	this.plugin.OnNetworkDisconnected = 'Player.OnNetworkDisconnected';
	this.plugin.OnStreamNotFound = 'Player.OnStreamNotFound';
	this.plugin.OnRenderError = 'Player.OnRenderError';
	this.plugin.onServerError = 'Player.onServerError';
	
	this.plugin.onRenderError = 'Player.onRenderError';
	this.plugin.onRenderingComplete = 'Player.onRenderingComplete';

    //this.plugin.SetTotalBufferSize(1024);  
    //this.plugin.SetInitialBuffer(2);
	    //this.plugin.SetInitialTimeOut(20);
	    //this.plugin.SetTotalBufferSize(/*(this._bufferTime / 2)*/1024);
	    //this.plugin.SetInitialBuffer(1); // %age of total buffer
	    //this.plugin.SetPendingBuffer(2); // %age of total buffer
		
    return success;
}

Player.onRenderError = function(err)
{
	var error_msg = '';
	switch(err)
    {			
		case 0:
			error_msg ="Связь с сервером прервана !";
            break;
		case 1:
			error_msg ="Неподдерживаемый контейнер !";
            break;
		case 2:
			error_msg ="Неподдерживаемый видеокодек !";
            break;
		case 3:
			error_msg ="Неподдерживаемый аудиокодек !";
            break;
		case 4:
			error_msg ="Неподдерживаемое видеоразрешение !";
            break;
		case 5:
			error_msg ="Файл отсутствует !";
            break;

		default:
            error_msg = err;
            break;			
	}		
   
	Display.status(error_msg);
	ConsoleLog('ERROR');
}


Player.onRenderingComplete = function()
{
    //VIDEO STOP
	Display.status("Rendering Complete!");
	ConsoleLog('Rendering Complete');
}


// Global functions called directly by the player 
Player.OnConnectionFailed = function()
{
    Display.status("Connection Failed!");
	//Player.matrixReload();
	ConsoleLog('OnConnectionFailed');
}

Player.OnNetworkDisconnected = function()
{
	Display.status("Network Disconnected!");
	//Player.matrixReload();
	ConsoleLog('Network Disconnected');
}

Player.OnStreamNotFound = function()
{
	Display.status("Stream NotFound!");
	ConsoleLog('Stream NotFound!');
}

Player.OnStreamInfoReady = function()
{
	Player.setSize(Player.size, 0);
	ConsoleLog('Player.plugin.GetDuration() ' + Player.plugin.GetDuration());
}
		
Player.OnRenderError = function()
{
    Display.status("Render Error!");
	ConsoleLog('Render Error!');
}

Player.onServerError = function()
{
	Display.status("Server Error!");
	ConsoleLog('Server Error!');
}

getBandwidth = function(bandwidth) { ConsoleLog("getBandwidth " + bandwidth); }

onDecoderReady = function() { ConsoleLogt("onDecoderReady"); }

onRenderError = function() { ConsoleLog("onRenderError"); }
			
Player.livestreamAutoReload = function()
{
	if(this.timer_is_on)
	{
		this.timer_is_on = 0;
		Main.PlayChannel();
		Display.status("AUTORECONNECT");
	}
}

Player.onBufferingStart = function()
{
    Display.status("Buffering...");
	ConsoleLog("Buffering...");
	this.timer_is_on = 1;
	if(KTV_API.reconnect!=0)
		this.kinozal_live_reloader = setTimeout("Player.livestreamAutoReload();", KTV_API.reconnect*1000);
}

Player.onBufferingProgress = function(percent)
{
    Display.status("Buffering:" + percent + "%");
	ConsoleLog("Buffering:" + percent + "%");
}

Player.onBufferingComplete = function()
{
	Display.status("Buffering Complete");
	Player.ShowResolution();
	ConsoleLog("Buffering Complete");
	clearTimeout(this.kinozal_live_reloader);
	this.timer_is_on = 0;
}

Player.deinit = function()
{
	if(this.state)
		this.stopVideo();
	ConsoleLog("Player deinit !!! " ); 
	if(this.mwPlugin != null)
		this.mwPlugin.SetMediaSource(this.originalSource);
	
	if (this.plugin)
	{
		this.plugin.Stop();
	}
}

Player.setVideoURL = function(url)
{
    this.url = url;
    ConsoleLog("URL = " + this.url);
}

Player.playVideo = function()
{	
	if(this.state == this.PLAYING_LIVE)
		this.stopVideo();
		
	if(this.state == this.PLAYING_VOD)
		this.stopVideo();
	
	if(Player.state == Player.PLAYING_ARCHIVE)
	{
		this.stopVideo();
	}
	
	if (this.url == null)
    {
        ConsoleLog("No videos to play");
    }
    else
    {
        this.state = this.PLAYING_LIVE;
		pluginAPI.setOffScreenSaver();
        this.plugin.Play( this.url );
        Audio.plugin.SetSystemMute(false); 
    }
	ConsoleLog("Play");
	this.chan_list_updater_counter = 0;
	
}

Player.stopVideo = function()
{
	//Display.status("Stop");
	if (this.state != this.STOPPED)
    {
        this.state = this.STOPPED;
        //Display.status("Stop");
        this.plugin.Stop();
    }

}

Player.getState = function()
{
    return this.state;
}

stopPlayer = function()
{
    Player.stopVideo();
}

Player.ShowResolution = function()
{
	var h=this.plugin.GetVideoHeight();
	var w=this.plugin.GetVideoWidth();
	var res = "<center>" + w + "X" + h + "</center>";
	widgetAPI.putInnerHTML(document.getElementById("resolution"), res);
			
}		

//getCurrentBitrates
//setVideoUnderflowBufferSize
//setPendingBuffer
//setInitialBuffer
//setTotalBufferSize


Player.setTottalBuffer = function(buffer) 
{ 
	var new_buffer = this.plugin.setTotalBufferSize(buffer);
	ConsoleLog("setTottalBuffer " + new_buffer); 
	Display.status(new_buffer);

}

Player.setInitialBuffer = function(buffer) 
{ 
	
	var new_buffer = this.plugin.setInitialBuffer(buffer);
	ConsoleLog("setInitialBuffer " + new_buffer); 


}

/*

Player.getCurrentBitrates = function()
{

	var bitrate = this.plugin.getCurrentBitrates();
	ConsoleLog("getCurrentBitrates " + bitrate); 

}
*/

Player.setSize=function(mode, show)
{
	if (this.state != this.STOPPED)
	{
		this.size=mode;

		var h=this.plugin.GetVideoHeight();
		var w=this.plugin.GetVideoWidth();
		switch(mode)
		{
			case 0 :
				//[16x9]
				if(show>0)
					Display.status('16x9 FULL');
				this.plugin.SetDisplayArea(0, 0, 960, 540);
				break;
				
			case 1 :
				var z = 960/w;//0,75
				var m = parseInt(z*h);
				var y = parseInt((540-m)/2);
				if(w/h>1.777)
				{
					if(show>0)
						Display.status('16x9 ORIGINAL');
					this.plugin.SetDisplayArea(0, y, 960, m);
				}
				else
				{
					if(show>0)
						Display.status('4x3 KINOZOOM');
					this.plugin.SetCropArea(0, 70, w, 436);
					this.plugin.SetDisplayArea(0, 0, 960, 540);
				}
				break;
			
			case 2 :
				//[4x3]
				if(w<=720)
				{
					if(show>0)
						Display.status('4x3');
					this.plugin.SetCropArea(0, 0, w, h);
					this.plugin.SetDisplayArea(120,0,720,540);
				}
				else
					Display.status('не поддерживается');
				break;		   
			

		}
	}
}

Player.getSize=function() {return this.size;}

Player.MinutesJump = function(minutes) 
{
	var sign = "";
	if(minutes>0)
		var sign = "+";
	this.statusmessage =sign + minutes + " мин.";
	if (minutes > 0) {
		this.plugin.JumpForward(minutes*60);    
	} else if (minutes < 0) {
		this.plugin.JumpBackward(minutes*60*-1);
	}
	Display.status(this.statusmessage);
}

Player.PercentJump = function(percent) 
{
	this.statusmessage = percent*10 + "%";
	var jump_time = 0;
	if(percent)
		jump_time = parseInt((this.vod_current_time + this.vod_one_percent*percent*10)/1000);
	
	var now_percent = parseInt(this.vod_current_time/this.vod_one_percent);
	var jump_to_percent = percent*10 - now_percent;
	var jump_to_minutes = (this.vod_one_percent*jump_to_percent)/1000;
	
	if (jump_to_minutes > 0) {
		this.plugin.JumpForward(jump_to_minutes);    
	} else if (jump_to_minutes < 0) {
		this.plugin.JumpBackward(jump_to_minutes*-1);
	}
	Display.status(this.statusmessage);
}

Player.resumeVideo = function()
{
	if (this.state != this.STOPPED)
	{
		this.state = this.PLAYING_VOD;
		this.plugin.Resume();
		document.getElementById("vod_pause").style.display="";
		document.getElementById("vod_play").style.display="none";
		Display.status('воспроизведение');
	}
}

Player.pauseVideo = function()
{
	if (this.state != this.STOPPED)
	{
		this.state = this.PAUSA_VOD;
		this.plugin.Pause();
		document.getElementById("vod_pause").style.display="none";
		document.getElementById("vod_play").style.display="";
		document.getElementById("statusbar").style.display="";
		widgetAPI.putInnerHTML(Display.statusDiv, "ПАУЗА");
	}
}

Player.setSpeed=function(speed)
{
	this.plugin.SetPlaybackSpeed(speed);
	Display.status('this.plugin.SetPlaybackSpeed ' + speed);
}

Player.HideCossEyeHelpBar = function() 
{
	document.getElementById("crosseye").style.display="none";
}

Player.HideCossEyeMode = function()    
{
	document.getElementById("crosseye").style.display="";
	var h=this.plugin.GetVideoHeight();
	var w=this.plugin.GetVideoWidth();
	var z = 960/w;//0,75
	h = parseInt(z*h/2);
	this.plugin.SetDisplayArea(0,(540-h)/2,960,h);
}

Player.matrixReload = function()
{
	KTV_API.SID = null;
	Main.PlayChannel();
	Display.status("RELOAD");
}

Player.CurrentTime = function(time)
{	

	var new_time = parseInt(time/1000);
	if(new_time % 5 == 0 && new_time != this.timer_helper)
	{

		this.timer_helper = new_time;
		KTV_API.servertime = KTV_API.servertime + 5;
		if(Player.state == Player.PLAYING_ARCHIVE)
		{
			ArchivePlayer.current_archive_time = ArchivePlayer.current_archive_time + 5;
			ArchivePlayer.UpdatePlayerStatusbar();
			ArchivePlayer.TimeChecker();
		}
		if(this.state == this.PLAYING_LIVE)
		{
			Player.LivePlayerRefresh();
		}
		
		//Player.setOnlineState();
	}
	
	if(this.state == this.PLAYING_VOD)
	{
		this.vod_current_time = parseInt(time);
		this.vod_duration = Player.plugin.GetDuration();
		this.vod_one_percent = parseInt(this.vod_duration/100);
		VideothekPlayer.UpdatePlayerStatusbar();
	}
	if(this.state == this.PLAYING_VOD || this.state == this.PAUSA_VOD)
		document.getElementById("vod_backtoplay_button").style.display="";
	else
		document.getElementById("vod_backtoplay_button").style.display="none";
		
}


Player.LivePlayerRefresh=function() 
{
	try
	{
		var time_end = parseInt(KTV_API.channels[Main.chan_array_index][5]);
		
		if(time_end && (KTV_API.servertime > time_end))
		{
			KTV_API.getChannel_list();
			Main.updateCurrentChannelEPG();
			Display.showplayer();
		}

	} catch(e){
		alert(e);
	}
	Main.UpdatePlayerStatusbar();
}
/*
Player.setOnlineState = function() 
{

	alert('this.chan_list_updater_counter ' + this.chan_list_updater_counter);
	var url = "";
	if(this.chan_list_updater_counter % 12 == 0 || this.chan_list_updater_counter == 0) //%12 = 60 sek
	{	
		if(this.state == this.PLAYING_LIVE)
			url = "http://stats.pristavka.de/nktv_samsung_set_stat_10.php?user_id="+Main.user_md5+"&ch_id="+Main.ch_id_selected+"&version="+Main.version+"&box_mac="+Main.mac_md5+"&hw="+Main.hardware;

		if(this.state == this.PLAYING_VOD)
			url = "http://stats.pristavka.de/nktv_samsung_set_stat_10.php?user_id="+Main.user_md5+"&film="+VideothekPlayer.vod_list[VideothekPlayer.vod_selected_item][5]+"&version="+Main.version+"&box_mac="+Main.mac_md5+"&hw="+Main.hardware;

		if(this.state == this.PLAYING_ARCHIVE)
			url = "http://stats.pristavka.de/nktv_samsung_set_stat_10.php?archive=1&user_id="+Main.user_md5+"&ch_id="+Main.ch_id_selected+"&version="+Main.version+"&box_mac="+Main.mac_md5+"&hw="+Main.hardware;
	}
	
	Main.showDateAndTime();
	
	this.chan_list_updater_counter = this.chan_list_updater_counter + 1;

	if(this.chan_list_updater_counter == 12*30) //12=60 sec
	{
		this.chan_list_updater_counter = 0;
		KTV_API.getChannel_list();
	
	}


	if(url!="")
	{
		ConsoleLog('STATS url' + url);
		var xhr=new XMLHttpRequest();
		xhr.open("GET", url, false);
		xhr.send();
	}

}
*/